/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  .oooooo.    oooooooooooo    ooooo        oooooooooooo   .oooooo.    oooooooooooo ooooo      ooo oooooooooo.    oooooooooooo//
// d8P'  `Y8b  d'""""""d888'    `888'        `888'     `8  d8P'  `Y8b   `888'     `8 `888b.     `8' `888'   `Y8b  d'""""""d888'//
//888      888       .888P   +   888          888         888            888          8 `88b.    8   888      888       .888P  //
//888      888      d888'   +++  888          888oooo8    888            888oooo8     8   `88b.  8   888      888      d888'   //
//888      888    .888P      +   888          888    "    888     ooooo  888    "     8     `88b.8   888      888    .888P     //
//`88b    d88'   d888'    .P     888       o  888       o `88.    .88'   888       o  8       `888   888     d88'   d888'    .P//
// `Y8bood8P'  .8888888888P      o888ooooood8 o888ooooood8  `Y8bood8P'   o888ooooood8 o8o        `8  o888bood8P'  .8888888888P //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Legendz HitMark v2.0 -DaJ4ck3L
//

$Legendz::HitMark = true; //this will turn the hitmark on / off
$Legendz::RainbowX = false; //flashes the hitmark with different predefined colors (someone could probably make better colors for this)
$Legendz::HitMark4Team = true; //green / red hitmarks 4 friendly / enemy (colors can be changed below. should be noted both arghs and legendz use same team dueling / fighting)
$Legendz::HitMarkDist = 600; //here put the distance in meters (5-1000) or set to false (displays predefined small / med / large X, doesnt work with rainbow)
$Legendz::HitMarkEnemy = "HitMarkRedTransMed.png"; //hitmark image displayed for enemy (this will auto set the size based on Small (32) / Med (64) / Large (128))
$Legendz::HitMarkFriendly = "HitMarkGreenTransMed.png"; //hitmark image displayed for friendly (if u add a new img make sure it's one of these 3 sizes with the words above in the name)
$Legendz::HitMarkTime = 1; //this will change the time the hitmark is displayed on the screen

function remoteLegendz::Hit(%cl, %target, %dist)
{
	if(!$Legendz::HitMark)
		return;
	
	//%target = guys name
	//%dist = distance
	//might add damage in future. idk.
	echo("--- Hit Marker --- Legendz ---");
	echo("-- Target hit: "@%target);
	echo("-- Distance hit: "@%dist);
	
	%me = getManagerId();
	%myteam = Client::getTeam(%me);
	
	%him = getClientByName(%target);
	%histeam = Client::getTeam(%him);
	
	//if you want to change an image make sure to fill out the proper x and y dimensions
	//image, time displayed, x dimension of img, y dimension of img
	if($Legendz::RainbowX)
	{
		hitmarkEP("<B0,0:HitMark/HitMarkBlackMed.png>", 0.15, 64, 64);
		schedule::add("hitmarkEP(\"<B0,0:HitMark/HitMarkBlueMed.png>\", 0.15, 64, 64);", 0.16);
		schedule::add("hitmarkEP(\"<B0,0:HitMark/HitMarkRedMed.png>\", 0.15, 64, 64);", 0.31);
		schedule::add("hitmarkEP(\"<B0,0:HitMark/HitMarkGreenMed.png>\", 0.15, 64, 64);", 0.46);
		schedule::add("hitmarkEP(\"<B0,0:HitMark/HitMarkWhiteMed.png>\", 0.15, 64, 64);", 0.61);
		schedule::add("hitmarkEP(\"<B0,0:HitMark/HitMarkBlackMed.png>\", 0.15, 64, 64);", 0.76);
		schedule::add("hitmarkEP(\"<B0,0:HitMark/HitMarkRedMed.png>\", 0.15, 64, 64);", 0.91);
		schedule::add("hitmarkEP(\"<B0,0:HitMark/HitMarkWhiteMed.png>\", 0.15, 64, 64);", 1.06);
		return;
	}
	else if(%myteam == %histeam && $Legendz::HitMark4Team)
	{
		if(%dist > $Legendz::HitMarkDist && $Legendz::HitMarkDist != false)
		{
			hitmarkEP("<B0,0:HitMark/HitMarkGreenTransSmall.png>", 0.35, 32, 32);
			schedule::add("hitmarkEP(\"<B0,0:HitMark/HitMarkGreenTransMed.png>\", 0.35, 64, 64);", 0.36);
			schedule::add("hitmarkEP(\"<B0,0:HitMark/HitMarkGreenTransLarge.png>\", 0.35, 128, 128);", 0.71);
			return;
		
		}
		else
		{
			if(String::findSubStr($Legendz::HitMarkFriendly,"Small") != "-1")
				%xy = 32;
			else if(String::findSubStr($Legendz::HitMarkFriendly,"Med") != "-1")
				%xy = 64;
			else if(String::findSubStr($Legendz::HitMarkFriendly,"Large") != "-1")
				%xy = 128;
			else
			{
				hitmarkEP("<F2>ERROR!! Please make sure your hitmark image is properly named!! <JC><F1>(Small / Med / Large)", 5, 420, 200);
				return;
			}
			
			if($debughxy)
			{
				echo($Legendz::HitMarkFriendly@" << $Legendz::HitMarkFriendly");
				echo($Legendz::HitMarkTime@" << $Legendz::HitMarkTime");
				echo(%xy@" << %xy");
			}
				
			hitmarkEP("<B0,0:HitMark/"@$Legendz::HitMarkFriendly@">", $Legendz::HitMarkTime, %xy, %xy); //the magic
		}
	}
	else
	{
		if(%dist > $Legendz::HitMarkDist && $Legendz::HitMarkDist != false)
		{
			hitmarkEP("<B0,0:HitMark/HitMarkRedTransSmall.png>", 0.35, 32, 32);
			schedule::add("hitmarkEP(\"<B0,0:HitMark/HitMarkRedTransMed.png>\", 0.35, 64, 64);", 0.36);
			schedule::add("hitmarkEP(\"<B0,0:HitMark/HitMarkRedTransLarge.png>\", 0.35, 128, 128);", 0.71);
			return;
		
		}
		else
		{
			if(String::findSubStr($Legendz::HitMarkEnemy,"Small") != "-1")
				%xy = 32;
			else if(String::findSubStr($Legendz::HitMarkEnemy,"Med") != "-1")
				%xy = 64;
			else if(String::findSubStr($Legendz::HitMarkEnemy,"Large") != "-1")
				%xy = 128;
			else
			{
				hitmarkEP("<F2>ERROR!! Please make sure your hitmark image is properly named!! <JC><F1>(Small / Med / Large)", 5, 420, 200);
				return;
			}
			
			if($debughxy)
			{
				echo($Legendz::HitMarkEnemy@" << $Legendz::HitMarkEnemy");
				echo($Legendz::HitMarkTime@" << $Legendz::HitMarkTime");
				echo(%xy@" << %xy");
			}
			
			hitmarkEP("<B0,0:HitMark/"@$Legendz::HitMarkEnemy@">", $Legendz::HitMarkTime, %xy, %xy); //is real
		}
	}
		
}

function Legendz::HitMarkC()
{
	remoteEval( 2048, Legendz::Hitmarker);
}

Event::Attach(eventConnected, Legendz::HitMarkC);

//old school presto <3
//1.11
$Presto::screenSize["320x240(V)"] = "320 240";
$Presto::screenSize["400x300(V)"] = "400 300";
$Presto::screenSize["480x360(V)"] = "480 360";
$Presto::screenSize["512x384"] = "512 384";
$Presto::screenSize["640x400"] = "640 400";
//1.40
$Presto::screenSize["1024x768"] = "1024 768";
$Presto::screenSize["1152x864"] = "1152 864";
$Presto::screenSize["1176x664"] = "1176 664";
$Presto::screenSize["1280x1024"] = "1280 1024";
$Presto::screenSize["1280x720"] = "1280 720";
$Presto::screenSize["1280x768"] = "1280 768";
$Presto::screenSize["1280x800"] = "1280 800";
$Presto::screenSize["1280x960"] = "1280 960";
$Presto::screenSize["1360x768"] = "1360 768";
$Presto::screenSize["1366x768"] = "1366 768";
$Presto::screenSize["1440x900"] = "1440 900";
$Presto::screenSize["1600x1024"] = "1600 1024";
$Presto::screenSize["1600x900"] = "1600 900";
$Presto::screenSize["1680x1050"] = "1680 1050";
$Presto::screenSize["1768x992"] = "1768 992";
$Presto::screenSize["1920x1080"] = "1920 1080";
$Presto::screenSize["640x480"] = "640 480";
$Presto::screenSize["720x480"] = "720 480";
$Presto::screenSize["720x576"] = "720 576";
$Presto::screenSize["800x600"] = "800 600";
//put whatever your normal resoultion is below, mine is 1920 1080
$Presto::screenSize["Default"] = "1920 1080";

function Presto::ScreenSize() 
{
	%res = $pref::videoFullScreenRes;
	if ($pref::VideoFullScreen) 
	{
		%posRes = $Presto::screenSize[%res];
		if (%posRes != "")
			return %posRes;
	}
	return $Presto::screenSize["Default"];
}

// converted this EP script to display the hitmark -DaJ4ck3L
function hitmarkEP::Init() 
{
	$hitmarkEP::Container = newObject("hitmarkEP",      SimGui::Control,      0, 0, 0, 0);
	%hitmarkEP::Text      = newObject("hitmarkEP_Text", FearGuiFormattedText, 0, 0, 0, 0);

	addToSet($hitmarkEP::Container, %hitmarkEP::Text);

	Control::setVisible("hitmarkEP", false);
}

function hitmarkEP::GuiOpen(%gui) 
{
	if(%gui != playGui)
	  return;

	addToSet(playGui, $hitmarkEP::Container);
}

function hitmarkEP::GuiClose(%gui) 
{
	if(%gui != playGui)
	  return;

	removeFromSet($hitmarkEP::Container);
}

function hitmarkEP::Destroy() 
{
	deleteObject($hitmarkEP::Container);
}

function hitmarkEP(%msg, %time, %xhud, %yhud)
{
	//schedule::cancel("Control::setVisible(hitmarkEP, false);");
	
	%screensize = Presto::ScreenSize();
	%x = getWord(%screensize, 0);
	%y = getWord(%screensize, 1);
	%xpos = %x / 2 - %xhud / 2;
	%ypos = %y / 2 - %yhud / 2;
	
	if($debughxy) //just in case -DaJ4ck3L
	{
		echo(%x@" << x1");
		echo(%y@" << y1");
		echo(%xpos@" << x2");
		echo(%ypos@" << y2");
	}
	
	Control::SetPosition("hitmarkEP", %xpos, %ypos);
	Control::setExtent("hitmarkEP", %xhud, %yhud);
	Control::setVisible("hitmarkEP", true);
	Control::setValue("hitmarkEP_Text", %msg);

	schedule::add("Control::setVisible(hitmarkEP, false);", %time);
	
	if(%time == "")
		schedule::add("Control::setVisible(hitmarkEP, false);", 1);
}

function hitmarkEPoff()
{
	Control::setVisible(hitmarkEP, false);
}

//create some binds in the options menu
function LegendzOOB::addBindsToMenu() after GameBinds::Init
{
	GameBinds::SetMapNoClearBinds( "actionMap.sae" );
	GameBinds::addBindCommand( "HitMark Toggle", "LegendzHitMark::Toggle();" );
	GameBinds::addBindCommand( "HitMark4Team Toggle", "LegendzHitMark4::Toggle();" );
}

//this turns the script on and off
function LegendzHitMark::Toggle()
{
	if($Legendz::HitMark == true)
	{
		$Legendz::HitMark = false;
		LegendzHitMark::bottomPrint("Deactivated!",3);
	}
	else if($Legendz::HitMark == false)
	{
		$Legendz::HitMark = true;
		LegendzHitMark::bottomPrint("Activated!",3);
	}
}

function LegendzHitMark::bottomPrint(%msg,%time) {
	$centerPrintId++;
	Client::centerPrint("<jc><f1>Legendz HitMark Toggle <f0>v2.0 - By: <f1>DaJ4ck3L\n<jc><f2>" @ %msg,1);
	schedule("clearCenterPrint(" @ $centerPrintId @ ");", %time);
}

//and a toggle for team hitmarks
function LegendzHitMark4::Toggle()
{
	if($Legendz::HitMark4Team == true)
	{
		$Legendz::HitMark4Team = false;
		LegendzHitMark4::bottomPrint("Deactivated!",3);
	}
	else if($Legendz::HitMark4Team == false)
	{
		$Legendz::HitMark4Team = true;
		LegendzHitMark::bottomPrint("Activated!",3);
	}
}

function LegendzHitMark4::bottomPrint(%msg,%time) {
	$centerPrintId++;
	Client::centerPrint("<jc><f1>Legendz HitMark4Team Toggle <f0>v2.0 - By: <f1>DaJ4ck3L\n<jc><f2>" @ %msg,1);
	schedule("clearCenterPrint(" @ $centerPrintId @ ");", %time);
}

Event::Attach(eventGuiClose, hitmarkEP::GuiClose);
Event::Attach(eventGuiOpen, hitmarkEP::GuiOpen);
Event::Attach(eventExit, hitmarkEP::Destroy);

hitmarkEP::Init();
